// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: accelfin-server-demo-fx-dtos.proto

package com.accelfin.server.demo.fx.dtos;

/**
 * Protobuf type {@code com.accelfin.server.demo.fx.dtos.OrderBookRungDto}
 */
public  final class OrderBookRungDto extends
    com.google.protobuf.GeneratedMessage implements
    // @@protoc_insertion_point(message_implements:com.accelfin.server.demo.fx.dtos.OrderBookRungDto)
    OrderBookRungDtoOrBuilder {
  // Use OrderBookRungDto.newBuilder() to construct.
  private OrderBookRungDto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
    super(builder);
  }
  private OrderBookRungDto() {
    type_ = 0;
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
  }
  private OrderBookRungDto(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    int mutable_bitField0_ = 0;
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!input.skipField(tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (rate_ != null) {
              subBuilder = rate_.toBuilder();
            }
            rate_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(rate_);
              rate_ = subBuilder.buildPartial();
            }

            break;
          }
          case 18: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (marketSizeNotional_ != null) {
              subBuilder = marketSizeNotional_.toBuilder();
            }
            marketSizeNotional_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(marketSizeNotional_);
              marketSizeNotional_ = subBuilder.buildPartial();
            }

            break;
          }
          case 24: {
            int rawValue = input.readEnum();

            type_ = rawValue;
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderBookRungDto_descriptor;
  }

  protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderBookRungDto_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.accelfin.server.demo.fx.dtos.OrderBookRungDto.class, com.accelfin.server.demo.fx.dtos.OrderBookRungDto.Builder.class);
  }

  /**
   * <pre>
   * adding this as a nested type so the names don't clash with the SideDto names (they have to be unique per package)
   * </pre>
   *
   * Protobuf enum {@code com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto}
   */
  public enum OrderBookRungTypeDto
      implements com.google.protobuf.ProtocolMessageEnum {
    /**
     * <code>BUY = 0;</code>
     */
    BUY(0),
    /**
     * <code>SELL = 1;</code>
     */
    SELL(1),
    /**
     * <code>MID = 2;</code>
     */
    MID(2),
    UNRECOGNIZED(-1),
    ;

    /**
     * <code>BUY = 0;</code>
     */
    public static final int BUY_VALUE = 0;
    /**
     * <code>SELL = 1;</code>
     */
    public static final int SELL_VALUE = 1;
    /**
     * <code>MID = 2;</code>
     */
    public static final int MID_VALUE = 2;


    public final int getNumber() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalArgumentException(
            "Can't get the number of an unknown enum value.");
      }
      return value;
    }

    /**
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static OrderBookRungTypeDto valueOf(int value) {
      return forNumber(value);
    }

    public static OrderBookRungTypeDto forNumber(int value) {
      switch (value) {
        case 0: return BUY;
        case 1: return SELL;
        case 2: return MID;
        default: return null;
      }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<OrderBookRungTypeDto>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static final com.google.protobuf.Internal.EnumLiteMap<
        OrderBookRungTypeDto> internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<OrderBookRungTypeDto>() {
            public OrderBookRungTypeDto findValueByNumber(int number) {
              return OrderBookRungTypeDto.forNumber(number);
            }
          };

    public final com.google.protobuf.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      return getDescriptor().getValues().get(ordinal());
    }
    public final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptor() {
      return com.accelfin.server.demo.fx.dtos.OrderBookRungDto.getDescriptor().getEnumTypes().get(0);
    }

    private static final OrderBookRungTypeDto[] VALUES = values();

    public static OrderBookRungTypeDto valueOf(
        com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new java.lang.IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      if (desc.getIndex() == -1) {
        return UNRECOGNIZED;
      }
      return VALUES[desc.getIndex()];
    }

    private final int value;

    private OrderBookRungTypeDto(int value) {
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto)
  }

  public static final int RATE_FIELD_NUMBER = 1;
  private com.accelfin.server.messaging.dtos.DecimalDto rate_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto rate = 1;</code>
   */
  public boolean hasRate() {
    return rate_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto rate = 1;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getRate() {
    return rate_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : rate_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto rate = 1;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getRateOrBuilder() {
    return getRate();
  }

  public static final int MARKET_SIZE_NOTIONAL_FIELD_NUMBER = 2;
  private com.accelfin.server.messaging.dtos.DecimalDto marketSizeNotional_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto market_size_notional = 2;</code>
   */
  public boolean hasMarketSizeNotional() {
    return marketSizeNotional_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto market_size_notional = 2;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getMarketSizeNotional() {
    return marketSizeNotional_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : marketSizeNotional_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto market_size_notional = 2;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getMarketSizeNotionalOrBuilder() {
    return getMarketSizeNotional();
  }

  public static final int TYPE_FIELD_NUMBER = 3;
  private int type_;
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto type = 3;</code>
   */
  public int getTypeValue() {
    return type_;
  }
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto type = 3;</code>
   */
  public com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto getType() {
    com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto result = com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto.forNumber(type_);
    return result == null ? com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto.UNRECOGNIZED : result;
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (rate_ != null) {
      output.writeMessage(1, getRate());
    }
    if (marketSizeNotional_ != null) {
      output.writeMessage(2, getMarketSizeNotional());
    }
    if (type_ != com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto.BUY.getNumber()) {
      output.writeEnum(3, type_);
    }
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (rate_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getRate());
    }
    if (marketSizeNotional_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getMarketSizeNotional());
    }
    if (type_ != com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto.BUY.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(3, type_);
    }
    memoizedSize = size;
    return size;
  }

  private static final long serialVersionUID = 0L;
  public static com.accelfin.server.demo.fx.dtos.OrderBookRungDto parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookRungDto parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookRungDto parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookRungDto parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookRungDto parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookRungDto parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookRungDto parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookRungDto parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookRungDto parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookRungDto parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.accelfin.server.demo.fx.dtos.OrderBookRungDto prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessage.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code com.accelfin.server.demo.fx.dtos.OrderBookRungDto}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessage.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:com.accelfin.server.demo.fx.dtos.OrderBookRungDto)
      com.accelfin.server.demo.fx.dtos.OrderBookRungDtoOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderBookRungDto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderBookRungDto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.accelfin.server.demo.fx.dtos.OrderBookRungDto.class, com.accelfin.server.demo.fx.dtos.OrderBookRungDto.Builder.class);
    }

    // Construct using com.accelfin.server.demo.fx.dtos.OrderBookRungDto.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
      }
    }
    public Builder clear() {
      super.clear();
      if (rateBuilder_ == null) {
        rate_ = null;
      } else {
        rate_ = null;
        rateBuilder_ = null;
      }
      if (marketSizeNotionalBuilder_ == null) {
        marketSizeNotional_ = null;
      } else {
        marketSizeNotional_ = null;
        marketSizeNotionalBuilder_ = null;
      }
      type_ = 0;

      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderBookRungDto_descriptor;
    }

    public com.accelfin.server.demo.fx.dtos.OrderBookRungDto getDefaultInstanceForType() {
      return com.accelfin.server.demo.fx.dtos.OrderBookRungDto.getDefaultInstance();
    }

    public com.accelfin.server.demo.fx.dtos.OrderBookRungDto build() {
      com.accelfin.server.demo.fx.dtos.OrderBookRungDto result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public com.accelfin.server.demo.fx.dtos.OrderBookRungDto buildPartial() {
      com.accelfin.server.demo.fx.dtos.OrderBookRungDto result = new com.accelfin.server.demo.fx.dtos.OrderBookRungDto(this);
      if (rateBuilder_ == null) {
        result.rate_ = rate_;
      } else {
        result.rate_ = rateBuilder_.build();
      }
      if (marketSizeNotionalBuilder_ == null) {
        result.marketSizeNotional_ = marketSizeNotional_;
      } else {
        result.marketSizeNotional_ = marketSizeNotionalBuilder_.build();
      }
      result.type_ = type_;
      onBuilt();
      return result;
    }

    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.accelfin.server.demo.fx.dtos.OrderBookRungDto) {
        return mergeFrom((com.accelfin.server.demo.fx.dtos.OrderBookRungDto)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.accelfin.server.demo.fx.dtos.OrderBookRungDto other) {
      if (other == com.accelfin.server.demo.fx.dtos.OrderBookRungDto.getDefaultInstance()) return this;
      if (other.hasRate()) {
        mergeRate(other.getRate());
      }
      if (other.hasMarketSizeNotional()) {
        mergeMarketSizeNotional(other.getMarketSizeNotional());
      }
      if (other.type_ != 0) {
        setTypeValue(other.getTypeValue());
      }
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      com.accelfin.server.demo.fx.dtos.OrderBookRungDto parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (com.accelfin.server.demo.fx.dtos.OrderBookRungDto) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto rate_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> rateBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto rate = 1;</code>
     */
    public boolean hasRate() {
      return rateBuilder_ != null || rate_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto rate = 1;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getRate() {
      if (rateBuilder_ == null) {
        return rate_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : rate_;
      } else {
        return rateBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto rate = 1;</code>
     */
    public Builder setRate(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (rateBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        rate_ = value;
        onChanged();
      } else {
        rateBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto rate = 1;</code>
     */
    public Builder setRate(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (rateBuilder_ == null) {
        rate_ = builderForValue.build();
        onChanged();
      } else {
        rateBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto rate = 1;</code>
     */
    public Builder mergeRate(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (rateBuilder_ == null) {
        if (rate_ != null) {
          rate_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(rate_).mergeFrom(value).buildPartial();
        } else {
          rate_ = value;
        }
        onChanged();
      } else {
        rateBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto rate = 1;</code>
     */
    public Builder clearRate() {
      if (rateBuilder_ == null) {
        rate_ = null;
        onChanged();
      } else {
        rate_ = null;
        rateBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto rate = 1;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getRateBuilder() {
      
      onChanged();
      return getRateFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto rate = 1;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getRateOrBuilder() {
      if (rateBuilder_ != null) {
        return rateBuilder_.getMessageOrBuilder();
      } else {
        return rate_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : rate_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto rate = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getRateFieldBuilder() {
      if (rateBuilder_ == null) {
        rateBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getRate(),
                getParentForChildren(),
                isClean());
        rate_ = null;
      }
      return rateBuilder_;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto marketSizeNotional_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> marketSizeNotionalBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto market_size_notional = 2;</code>
     */
    public boolean hasMarketSizeNotional() {
      return marketSizeNotionalBuilder_ != null || marketSizeNotional_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto market_size_notional = 2;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getMarketSizeNotional() {
      if (marketSizeNotionalBuilder_ == null) {
        return marketSizeNotional_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : marketSizeNotional_;
      } else {
        return marketSizeNotionalBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto market_size_notional = 2;</code>
     */
    public Builder setMarketSizeNotional(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (marketSizeNotionalBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        marketSizeNotional_ = value;
        onChanged();
      } else {
        marketSizeNotionalBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto market_size_notional = 2;</code>
     */
    public Builder setMarketSizeNotional(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (marketSizeNotionalBuilder_ == null) {
        marketSizeNotional_ = builderForValue.build();
        onChanged();
      } else {
        marketSizeNotionalBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto market_size_notional = 2;</code>
     */
    public Builder mergeMarketSizeNotional(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (marketSizeNotionalBuilder_ == null) {
        if (marketSizeNotional_ != null) {
          marketSizeNotional_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(marketSizeNotional_).mergeFrom(value).buildPartial();
        } else {
          marketSizeNotional_ = value;
        }
        onChanged();
      } else {
        marketSizeNotionalBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto market_size_notional = 2;</code>
     */
    public Builder clearMarketSizeNotional() {
      if (marketSizeNotionalBuilder_ == null) {
        marketSizeNotional_ = null;
        onChanged();
      } else {
        marketSizeNotional_ = null;
        marketSizeNotionalBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto market_size_notional = 2;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getMarketSizeNotionalBuilder() {
      
      onChanged();
      return getMarketSizeNotionalFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto market_size_notional = 2;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getMarketSizeNotionalOrBuilder() {
      if (marketSizeNotionalBuilder_ != null) {
        return marketSizeNotionalBuilder_.getMessageOrBuilder();
      } else {
        return marketSizeNotional_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : marketSizeNotional_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto market_size_notional = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getMarketSizeNotionalFieldBuilder() {
      if (marketSizeNotionalBuilder_ == null) {
        marketSizeNotionalBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getMarketSizeNotional(),
                getParentForChildren(),
                isClean());
        marketSizeNotional_ = null;
      }
      return marketSizeNotionalBuilder_;
    }

    private int type_ = 0;
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto type = 3;</code>
     */
    public int getTypeValue() {
      return type_;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto type = 3;</code>
     */
    public Builder setTypeValue(int value) {
      type_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto type = 3;</code>
     */
    public com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto getType() {
      com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto result = com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto.forNumber(type_);
      return result == null ? com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto.UNRECOGNIZED : result;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto type = 3;</code>
     */
    public Builder setType(com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto value) {
      if (value == null) {
        throw new NullPointerException();
      }
      
      type_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.OrderBookRungDto.OrderBookRungTypeDto type = 3;</code>
     */
    public Builder clearType() {
      
      type_ = 0;
      onChanged();
      return this;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }


    // @@protoc_insertion_point(builder_scope:com.accelfin.server.demo.fx.dtos.OrderBookRungDto)
  }

  // @@protoc_insertion_point(class_scope:com.accelfin.server.demo.fx.dtos.OrderBookRungDto)
  private static final com.accelfin.server.demo.fx.dtos.OrderBookRungDto DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.accelfin.server.demo.fx.dtos.OrderBookRungDto();
  }

  public static com.accelfin.server.demo.fx.dtos.OrderBookRungDto getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<OrderBookRungDto>
      PARSER = new com.google.protobuf.AbstractParser<OrderBookRungDto>() {
    public OrderBookRungDto parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
        return new OrderBookRungDto(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<OrderBookRungDto> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<OrderBookRungDto> getParserForType() {
    return PARSER;
  }

  public com.accelfin.server.demo.fx.dtos.OrderBookRungDto getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

